# -*- coding: utf-8 -*-
import mod.client.extraClientApi as clientApi
from ChestLockScripts.config.sys import MOD_PASSWORD_SAVE_EVENT, MOD_PASSWORD_CHECK_EVENT

ScreenNode = clientApi.GetScreenNodeCls()
ViewBinder = clientApi.GetViewBinderCls()
ViewRequest = clientApi.GetViewViewRequestCls()

# 所有继承base_screen的自定义界面都携带一串长的路径
ROOT_PANEL = '/variables_button_mappings_and_controls/safezone_screen_matrix/inner_matrix/safezone_screen_panel/root_screen_panel'


class Main(ScreenNode):

    def __init__(self, namespace, name, param):
        ScreenNode.__init__(self, namespace, name, param)
        self.password = []
        self.client_sys = param['client']
        self.dimension = param['dimension']
        self.pos = param['pos']
        self.face = param['face']
        self.my_ui_name = param['ui_name']

    @ViewBinder.binding(ViewBinder.BF_EditChanged | ViewBinder.BF_EditFinished)
    def edit_password_str(self, event):
        text = event['Text']
        password = [int(i) for i in list(text)]
        self.password = password
        return ViewRequest.Refresh

    @ViewBinder.binding(ViewBinder.BF_BindString, '#chest_lock.message_content_text_edit_box0')
    def return_password_str(self):
        return ''.join(self.password)

    @ViewBinder.binding_collection(ViewBinder.BF_BindString, 'password_grid', '#password_number')
    def return_password_number(self, index):
        return '{}'.format(index + 1)

    # 绑定回调函数：点击关闭UI按钮
    @ViewBinder.binding(ViewBinder.BF_ButtonClickUp, '#on_close')
    def close(self, event):
        if len(self.password) == 4:
            # 通过判断点击面是否存在来判断玩家是否第一次放置了金锁子
            if self.face != -1:
                self.client_sys.NotifyToServer(MOD_PASSWORD_SAVE_EVENT, {'pos': list(self.pos), 'dimension': self.dimension,
                                                                         'face': self.face, 'playerId': clientApi.GetLocalPlayerId(),
                                                                         'password': self.password})
                clientApi.PopScreen()
            else:
                self.client_sys.NotifyToServer(MOD_PASSWORD_CHECK_EVENT,
                                               {'pos': list(self.pos), 'dimension': self.dimension,
                                                'playerId': clientApi.GetLocalPlayerId(),
                                                'password': self.password})
        return ViewRequest.Refresh

    # 绑定回调函数：点击9键按钮
    @ViewBinder.binding(ViewBinder.BF_ButtonClickUp,  '#click')
    def click(self, event):
        """
        :param event: dict({'#collection_index': 按在第几个网格按钮下，返回它的所处在的集合位置数字})
        :return:
        """
        # 按下数字按钮时，最多只能保存4个元素在密码列表里
        if len(self.password) < 4:
            self.password.append(str(event['#collection_index'] + 1))
        return ViewRequest.Refresh

    def Create(self):
        if self.face == -1:
            self.GetBaseUIControl(ROOT_PANEL + '/notice_label').asLabel().SetText('请输入正确密码以打开金锁子!')